package fi.jyu.mit.ohj2;

import java.io.*;

/**
 * Readkey.java
 *
 * Luokka yhden merkin lukemiseen,
 * tarvitsee polkuun joko tiedoston
 * libreadkey.so tai readkey.dll,
 * muutoin vaatii enterin painalluksen
 *
 * @author Markku Vire, Jukka Mntyl
 * @version 0.96 12.2.2003
 */
class Readkey
{
  private static native char getCharNative();
  private static boolean islib = false;
  private static BufferedReader linereader;

  static {
    try {
      System.loadLibrary("readkey");
      islib = true;
    }
    // Jos ei pystyt lataamaan kirjastoa, niin
    // kytetn default-versiota merkin lukemisessa
    catch (UnsatisfiedLinkError e) { }
    catch (SecurityException e) { }

    if (!islib) linereader = new BufferedReader(new InputStreamReader(System.in));

  }

  /**
   *
   * Lukee yhden merkin nppimistlt
   * @return Palauttaa luetun merkin
   */
  public static char getChar() {
    if (islib) return getCharNative();
    // default-versio:
    String s = "";
    try {
      s = linereader.readLine();
    } catch (IOException ex) {
    }
    if ( ( s == null ) || ( s.equals("") ) ) return '\n';
    return s.charAt(0);
  }

  /**
   * Palauttaa tiedon siit onko kyttjrjestelmkohtainen
   * readkey-kirjasto kytss
   * @return Palauttaa tiedon onko readkey-kirjasto kytss
   */
  public static boolean isLibLoaded() {
    return islib;
  }

  public static void main(String[] args)
  {
    if (isLibLoaded()) 
      System.out.print("readkey-kirjasto ladattu.\nAnna merkki:");
    else 
      System.out.print("readkey-kirjastoa ei lytynyt.\nAnna kirjain ja paina enter:");
    char c = Readkey.getChar();
    if (isLibLoaded()) System.out.println(c);
    System.out.println("Annoit merkin: " + c);
  }

}
