package fi.jyu.mit.ohj2;
import java.io.*;

/**
 * <p>Title: Tiedosto</p>
 * <p>Description: Aliohjelmia tiedostojen ksittelyyn</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: jyu </p>
 * @author Vesa Lappalainen
 * @version 1.0, 25.02.2003
 * @version 1.1, 09.03.2002
 */

public class Tiedosto {


  /**
   * Avaa tiedoston lukemista varten
   * @param nimi avattavan tiedoston nimi
   * @return avattu puskuroitu tiedostolukija tai null jos ei aukea
   */
  public static BufferedReader avaa_lukemista_varten(String nimi) {
    try {
      BufferedReader f = new BufferedReader(new FileReader(nimi));
      return f;
    } catch (FileNotFoundException ex) {
      return null;
    }
  }


  /**
   * Avaa tiedoston kirjoittamista varten.
   * @param nimi   avattavan tiedoston nimi
   * @param jatka  jatketaanko edellisen tiedoston pern (true) vai ei (false)
   * @return       avattu PrintWriter-olio tai null jos ei aukea
   */
  public static PrintWriter avaa_kirjoittamista_varten(String nimi,boolean jatka) {
    PrintWriter f = null;
      try {
        f = new PrintWriter(new FileWriter(nimi,jatka));
      } catch (IOException ex) {
        return null;
      }
    return f;
  }

  /**
   * Avaa tiedoston kirjoittamista varten.
   * @param nimi   avattavan tiedoston nimi
   * @return       avattu PrintWriter-olio tai null jos ei aukea
   */
  public static PrintWriter avaa_kirjoittamista_varten(String nimi) {
    return avaa_kirjoittamista_varten(nimi,false);
  }


  /**
   * Avaa tiedoston kirjoittamista varten.
   * @param nimi   avattavan tiedoston nimi
   * @param jatka  jatketaanko edellisen tiedoston pern (true) vai ei (false)
   * @return       avattu PrintStream-olio tai null jos ei aukea
   */
  public static PrintStream avaa_kirjoittamista_varten_stream(String nimi,boolean jatka) {
    PrintStream f = null;
    try {
      f = new PrintStream(new FileOutputStream(nimi,jatka));
    }  catch (FileNotFoundException ex) {
      return null;
    }
    return f;
  }

  /**
   * Avaa tiedoston kirjoittamista varten.
   * @param nimi   avattavan tiedoston nimi
   * @return       avattu PrintStream-olio tai null jos ei aukea
   */
  public static PrintStream avaa_kirjoittamista_varten_stream(String nimi) {
    return avaa_kirjoittamista_varten_stream(nimi,false);
  }


  /**
   * Luo tarvittaessa uuden PrintStream-virran OutputStream virrasta.
   * Jos os on valmiiksi PrintStream, niin tehdn vain tyypinmuunnos
   * @param os virta josta luodaan PrintStream virta
   * @return os muutettuna PrintStrean-virraksi
   */
  public static PrintStream getPrintStream(OutputStream os) {
    return (os instanceof PrintStream)?(PrintStream)os : new PrintStream(os) ;
  }


  public static void main(String[] args) {
  }
}
